import type { Editor, Position } from "codemirror";
import type { TextEdit } from "vscode-languageserver-protocol";
/**
 * Insert snippet by replacing the range (`from` `to`).
 *
 * @param cm - Editor
 * @param text - Snippet template.
 * @param from - The start of range to replace with the snippet.
 * @param to - The end of range to replace with the snippet.
 * @param edits - Additional edits from completion item.
 */
export declare const insertSnippet: (cm: Editor, text: string, from: Position, to: Position, edits?: TextEdit[] | undefined) => void;
