"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signal = exports.onEditorEvent = exports.fromEditorEvent = void 0;
const codemirror_1 = require("codemirror");
exports.fromEditorEvent = (target, type) => {
    return (cb) => {
        const untupled = (...args) => {
            cb(args);
        };
        target.on(type, untupled);
        return () => {
            target.off(type, untupled);
        };
    };
};
exports.onEditorEvent = (target, type, handler) => exports.fromEditorEvent(target, type)(handler);
/**
 * Typed wrapper around `CodeMirror.signal`.
 * @param editor - Editor instance
 * @param name - Event name
 * @param args - Event parameters
 */
exports.signal = (editor, name, ...args) => {
    codemirror_1.signal(editor, name, ...args);
};
//# sourceMappingURL=events.js.map