import type { Editor, Position } from "codemirror";
import type { CompletionItem } from "vscode-languageserver-protocol";
/**
 * Show completion triggered by typing an identifier or manual invocation.
 * @param editor
 * @param items - Completion items from the server.
 * @param tokenRange - Range describing the span of the typed identifier.
 */
export declare const showInvokedCompletions: (editor: Editor, items: CompletionItem[], [tokenFrom, tokenTo]: [Position, Position], renderMarkdown?: (x: string) => string) => void;
/**
 * Show completions triggered by a trigger character specified by the `triggerCharacters`.
 * Completion items are inserted differently from when it's invoked.
 * @param editor - The editor.
 * @param items - Completion items from the server.
 * @param pos - Current cursor position where the item will be inserted after.
 */
export declare const showTriggeredCompletions: (editor: Editor, items: CompletionItem[], pos: Position, renderMarkdown?: (x: string) => string) => void;
/**
 * Hide completion popup.
 * @param editor
 */
export declare const hideCompletions: (editor: Editor) => void;
