import type { Editor, TextMarker, Position } from "codemirror";
import type { TextEdit } from "vscode-languageserver-protocol";
/**
 * Apply text edits preserving cursor location.
 * @param cm - Editor
 * @param edits - Array of text edit to apply.
 * @param origin - Optional origin string to use.
 */
export declare const applyEdits: (cm: Editor, edits: TextEdit[], origin?: string | undefined) => void;
/**
 * Highlight range of text.
 * @param cm - Editor to operate on.
 * @param from - Start of the range to highlight
 * @param to - End of the range to highlight
 * @param duration - Clear after duration if given.
 */
export declare const highlightRange: (cm: Editor, from: Position, to: Position, duration?: number) => TextMarker;
